local StoneGate, StoneGateExtensionPrefix = ...

-- Apply building asset processor
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorMainWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorKeepWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallSquaredTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallGateWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorCircularTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorOctogonalTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallCircularTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorAngle45White.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorAngle45KeepWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerWoodenFloorOptionPart(_option)
    function registerWoodenFloorPart(_nameFbxFile, _nameFbx, _nameAsset, _villagerCapacity, _category)
        StoneGate:registerAssetId("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration roof part
        StoneGate:registerAsset({
	      DataType = "BUILDING_PART",
	      Id = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PART",
	      Name = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_NAME",
	      Description = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_DESC",
	      Category = _category,
	      ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		    CoreObjectPrefab = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	      },
	      Cost = {
		    UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		    },
		    ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 5*_NoSandbox }
		    }}
	      },
        })
    end
    function registerWoodenFloorPartWithFunctions(_nameFbxFile, _nameFbx, _nameAsset, _villagerCapacity, _category)
        StoneGate:registerAssetId("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration roof part
        StoneGate:registerAsset({
	      DataType = "BUILDING_PART",
	      Id = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PART",
	      Name = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_NAME",
	      Description = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_DESC",
	      Category = _category,
	      ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		    CoreObjectPrefab = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	      },
	      Cost = {
		    UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		    },
		    ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 5*_NoSandbox }
		    }}
	      },
            VillagerCapacity = _villagerCapacity,
--            AssetBuildingFunction = registerAssignableFunction(StoneGateExtensionPrefix, _nameAsset)
        })
    end

    registerWoodenFloorPartWithFunctions( "woodenFloorMainWhite", "step_2_WFMain" .. _option, "WFMAIN_" .. _option, 12, StoneGateSetPrefix .. "_MAIN_PARTSETLIST_NAME")
    registerWoodenFloorPartWithFunctions( "woodenFloorKeepWhite", "step_2_WFKeep" .. _option, "WFKEEP_" .. _option, 8, StoneGateSetPrefix .. "_KEEP_PARTSETLIST_NAME")
    registerWoodenFloorPartWithFunctions( "woodenFloorSmallSquaredTowerWhite", "step_2_WFSst" .. _option, "WFSST_" .. _option, 2, StoneGateSetPrefix .. "_SST_OTHER_PARTSETLIST_NAME")
    registerWoodenFloorPart( "woodenFloorSmallGateWhite", "step_2_WFSGate" .. _option, "WFSGATE_" .. _option, 2, StoneGateSetPrefix .. "_SGATE_PARTSETLIST_NAME")
    registerWoodenFloorPart( "woodenFloorAngle45White", "step_2_WFA45" .. _option, "WFA45_" .. _option, 0, StoneGateSetPrefix .. "_A45_PARTSETLIST_NAME")
    registerWoodenFloorPart( "woodenFloorAngle45KeepWhite", "step_2_WFAK45" .. _option, "WFAK45_" .. _option, 0, StoneGateSetPrefix .. "_AK45_PARTSETLIST_NAME" )
    registerWoodenFloorPartWithFunctions( "woodenFloorOctogonalTowerWhite", "step_2_WFOctogonal" .. _option, "WFOTOWER_" .. _option, 8, StoneGateSetPrefix .. "_OTOWER_PARTSETLIST_NAME")
    registerWoodenFloorPartWithFunctions( "woodenFloorCircularTowerWhite", "step_2_WFCircular" .. _option, "WFCIRCULAR_" .. _option, 6, StoneGateSetPrefix .. "_CIRCULAR_PARTSETLIST_NAME")
    registerWoodenFloorPartWithFunctions( "woodenFloorSmallCircularTowerWhite", "step_2_WFSct" .. _option, "WFSCT_" .. _option, 0, StoneGateSetPrefix .. "_SCT_PARTSETLIST_NAME")
end

registerWoodenFloorOptionPart("A")
registerWoodenFloorOptionPart("B")
registerWoodenFloorOptionPart("C")

function registerWoodenFloorPlatform(_nameFbxFile, _nameFbx)
    StoneGate:configurePrefabFlagList("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", { "PLATFORM" })
end
registerWoodenFloorPlatform( "woodenFloorSmallGateWhite", "step_2_WFSGateA")
registerWoodenFloorPlatform( "woodenFloorSmallGateWhite", "step_2_WFSGateB")
registerWoodenFloorPlatform( "woodenFloorSmallGateWhite", "step_2_WFSGateC")
